"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("v8-compile-cache");
const electron_1 = require("electron");
const path = __importStar(require("path"));
const node_localstorage_1 = require("node-localstorage");
const electron_debug_1 = __importDefault(require("electron-debug"));
const config_1 = __importDefault(require("./config"));
electron_debug_1.default({ showDevTools: false });
const storage = new node_localstorage_1.JSONStorage(electron_1.app.getPath('userData'));
const template = [
    {
        label: 'Edit',
        submenu: [
            {
                role: 'cut',
            },
            {
                role: 'copy',
            },
            {
                role: 'paste',
            },
            {
                role: 'delete',
            },
            {
                role: 'selectall',
            },
        ],
    },
    {
        label: 'View',
        submenu: [
            {
                label: 'Reload',
                accelerator: 'CmdOrCtrl+R',
                click(_, focusedWindow) {
                    if (focusedWindow)
                        focusedWindow.reload();
                },
            },
            {
                type: 'separator',
            },
            {
                role: 'togglefullscreen',
            },
        ],
    },
    {
        role: 'window',
        submenu: [
            {
                role: 'minimize',
            },
            {
                role: 'close',
            },
        ],
    },
    {
        role: 'help',
        submenu: [
            {
                label: 'Learn More',
                click() {
                    electron_1.shell.openExternal(config_1.default.sitePath);
                },
            },
        ],
    },
];
if (process.platform === 'darwin') {
    template.unshift({
        label: electron_1.app.name,
        submenu: [
            {
                role: 'about',
            },
            {
                type: 'separator',
            },
            {
                role: 'hide',
            },
            {
                role: 'hideothers',
            },
            {
                role: 'unhide',
            },
            {
                type: 'separator',
            },
            {
                role: 'quit',
            },
        ],
    });
    // Window menu
    template[3].submenu = [
        {
            label: 'Close',
            accelerator: 'CmdOrCtrl+W',
            role: 'close',
        },
        {
            label: 'Minimize',
            accelerator: 'CmdOrCtrl+M',
            role: 'minimize',
        },
    ];
}
let mainWindow;
let windowState;
const createWindow = () => {
    const defaultParams = {
        width: 960,
        height: 680,
        minWidth: 860,
        minHeight: 600,
        icon: `${__dirname}/icon/app.png`,
        show: false,
        webPreferences: {
            nodeIntegration: true,
            webviewTag: true,
        },
    };
    try {
        windowState = storage.getItem('windowstate') || {};
    }
    catch (e) { }
    const windowParams = (windowState === null || windowState === void 0 ? void 0 : windowState.bounds) ? Object.assign(Object.assign({}, defaultParams), windowState.bounds) : defaultParams;
    mainWindow = new electron_1.BrowserWindow(windowParams);
    mainWindow.loadFile(path.join(__dirname, '../index.html'));
    mainWindow.on('close', () => {
        windowState.bounds = mainWindow.getBounds();
        storage.setItem('windowstate', windowState);
    });
    mainWindow.on('closed', () => {
        mainWindow = null;
    });
    mainWindow.on('ready-to-show', () => {
        mainWindow.show();
        mainWindow.focus();
    });
};
electron_1.app.on('ready', () => {
    electron_1.app.applicationMenu = electron_1.Menu.buildFromTemplate(template);
    createWindow();
});
electron_1.app.on('window-all-closed', () => {
    if (process.platform !== 'darwin')
        electron_1.app.quit();
});
electron_1.app.on('activate', () => {
    if (mainWindow === null)
        createWindow();
});
